package com.fp.persistence.parmas.fun;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMSOLICITUDIMPORTACION*/
@Entity(name="TarmSolicitudImportacion")
@Table(name="TARMSOLICITUDIMPORTACION")
public class TarmSolicitudImportacion extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmSolicitudImportacion
*/
@EmbeddedId
private TarmSolicitudImportacionKey pk;
@Column(name="CPAISORIGEN", nullable=true)

/**
* Codigo de pais
*/
private String cpaisorigen;

@Column(name="FCREACION", nullable=true)

/**
* null
*/
private Date fcreacion;

@Column(name="FABRICANTE", nullable=true)

/**
* null
*/
private String fabricante;

@Column(name="DUI", nullable=true)

/**
* null
*/
private String dui;

@Column(name="TOTAL_FOB", nullable=true)

/**
* null
*/
private BigDecimal total_fob;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* null
*/
private Integer recordversion;

/**Contructor por defecto*/
public TarmSolicitudImportacion(){
}
/**Contructor de TarmSolicitudImportacion
@param pPk Clave Primaria del entity
*/
public TarmSolicitudImportacion(TarmSolicitudImportacionKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmSolicitudImportacion
*/
public static TarmSolicitudImportacion find(EntityManager pEntityManager,TarmSolicitudImportacionKey pKey) throws Exception{
    TarmSolicitudImportacion obj = pEntityManager.find(TarmSolicitudImportacion.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmSolicitudImportacion
@return El objeto que referencia a la Clave primaria de TarmSolicitudImportacion
*/
public TarmSolicitudImportacionKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmSolicitudImportacion
@param pPk El objeto que referencia a la nueva Clave primaria de TarmSolicitudImportacion
*/
public void setPk(TarmSolicitudImportacionKey pPk){
  pk=pPk;
}
/**Obtiene el valor de cpaisorigen
@return valor de cpaisorigen*/
public String getCpaisorigen(){
  return cpaisorigen;
}
/**Fija el valor de cpaisorigen
@param pCpaisorigen nuevo Valor de cpaisorigen*/
public void setCpaisorigen(String pCpaisorigen){
  cpaisorigen=pCpaisorigen;
}

/**Obtiene el valor de fcreacion
@return valor de fcreacion*/
public Date getFcreacion(){
  return fcreacion;
}
/**Fija el valor de fcreacion
@param pFcreacion nuevo Valor de fcreacion*/
public void setFcreacion(Date pFcreacion){
  fcreacion=pFcreacion;
}

/**Obtiene el valor de fabricante
@return valor de fabricante*/
public String getFabricante(){
  return fabricante;
}
/**Fija el valor de fabricante
@param pFabricante nuevo Valor de fabricante*/
public void setFabricante(String pFabricante){
  fabricante=pFabricante;
}

/**Obtiene el valor de dui
@return valor de dui*/
public String getDui(){
  return dui;
}
/**Fija el valor de dui
@param pDui nuevo Valor de dui*/
public void setDui(String pDui){
  dui=pDui;
}

/**Obtiene el valor de total_fob
@return valor de total_fob*/
public BigDecimal getTotal_fob(){
  return total_fob;
}
/**Fija el valor de total_fob
@param pTotal_fob nuevo Valor de total_fob*/
public void setTotal_fob(BigDecimal pTotal_fob){
  total_fob=pTotal_fob;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmSolicitudImportacion))return false;
    TarmSolicitudImportacion that = (TarmSolicitudImportacion) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmSolicitudImportacion
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmSolicitudImportacion
*/
public Object createInstance(){
 TarmSolicitudImportacion instance=new TarmSolicitudImportacion();	
 instance.setPk(new TarmSolicitudImportacionKey());
 return instance;
}
/**Clona la entidad TarmSolicitudImportacion
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmSolicitudImportacion p=(TarmSolicitudImportacion)this.clone();
  p.setPk((TarmSolicitudImportacionKey)this.pk.cloneMe());
  return p;
}
}
